define([
    "./app/Content",
    "./app/Page",
    "./app/Router",
    "./routes",
    "./store",
    "./store/request",
    "./ui/MainMenu",
    "dojo/_base/array",
    "dojo/parser",
    "dojo/request/registry",
    "./stddeps",
    "dojo/domReady!"
], function(Content, Page, Router, routes, store, request, MainMenu, array, parser, registry) {

    registry.register(/.*/,request);
    
    parser.parse();
    store.info()
    .then(function(){
        new MainMenu({},"menu").startup();
        array.forEach(routes,function(route){
            Router.register(route);
        });
        Router.startup();
    },function(){
        Content.startup();
        Content.set(new Page({
            templateString: "<div>Application database is not properly configured. Contact your system administrator.</div>"
        }));
    });
});
