var fs = require("fs");
var https = require("https");
var os = require("os");
var path = require("path");
var _ = require("underscore");

var app = require('./app').App({
    couchDbURL: 'http://localhost:5984/qed'
});

var httpsOptions = {
    key: fs.readFileSync(path.resolve('../qed-server.key')),
    cert: fs.readFileSync(path.resolve('../qed-server.pem'))
};

var server = https.createServer(httpsOptions, app);
server.listen(8443);

console.log(
    "Listening on " + 
    _.chain(os.networkInterfaces())
     .map(function(value,key){ return value; })
     .flatten()
     .filter(function(intf){ return intf.family === "IPv4" && !intf.internal; })
     .reduce(function(urls, intf){ return urls+', http://'+intf.address+':8443/'; }, "http://127.0.0.1:8443/")
     .value() + ".");
